//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _AB1784PKTX_
   #include "ab1784pktx.hpp"
#endif

#ifndef _STDEXCEPT_
   #include <stdexcept>
#endif

#ifndef _PCIBUS_
   #include "pcibus.hpp"
#endif

using namespace std;
using namespace Uniio;

//-----------------------------------------------------------------------------
AB1784PKTx::AB1784PKTx(  const char * const inFirmwarePath
                 , const unsigned inLinkSpeed
                 , const unsigned inCardId )
   : AB1784Card (getBaseAddress(inCardId), inFirmwarePath, inLinkSpeed, "AB1784PKTx")
{
BFUNCTRACE_DEVELOP();
}


//-----------------------------------------------------------------------------
AB1784PKTx::~AB1784PKTx()
{
BFUNCTRACE_DEVELOP();
}


//-----------------------------------------------------------------------------
unsigned long AB1784PKTx::getBaseAddress(const unsigned inCardId)
{
BFUNCTRACE_DEVELOP();
  const PCIDeviceInfo * anInfo = PCIBus::pciBus().getDeviceInfo(0x12A0, 0x000B, inCardId );
  if (anInfo)
  {
     return anInfo -> baseAddress(2);
  }
  else
  {
     throw logic_error ("AB1784PKTx: Card can not be found in the system.");
  }
  return 0;
}
